using System;
using System.Collections;
using System.Collections.Generic;

namespace Esempio1
{
    class Program
    {
        static void Main(string[] args)
        {
            //Step0();
            //Step1a();
            //Step1b();
            //Step2();
            //Step3();
            //Step4();
            Step5();
        }

        private static void Step0()
        {
            Console.WriteLine("100 == 100 -> {0}", 100 == 100);
            Console.WriteLine("100.Equals(100) -> {0}", 100.Equals(100));
            Console.WriteLine("Equals(100, 100) -> {0}", Equals(100, 100));
            Console.WriteLine("ReferenceEquals(100, 100) -> {0}", ReferenceEquals(100, 100));
            Console.WriteLine();
            Console.WriteLine("((object) 100) == ((object) 100) -> {0}", ((object) 100) == ((object) 100));
            Console.WriteLine("((object) 100).Equals(((object) 100)) -> {0}", ((object) 100).Equals(((object) 100)));
            Console.WriteLine("Equals(((object) 100), ((object) 100)) -> {0}", Equals(((object) 100), ((object) 100)));
            Console.WriteLine("ReferenceEquals(((object) 100), ((object) 100)) -> {0}", ReferenceEquals(((object) 100), ((object) 100)));
            Console.WriteLine();
        }

        private static void Step1a()
        {
            Random random = new Random();
            Point[] points = new Point[10];
            //foreach (Point point in points)
            //    Console.WriteLine("{0}", point);
            //foreach (Point point in points)
            //    point = new Point(random.Next(0, 100), random.Next(0, 100));
            for (int k = 0; k < points.Length; k++)
                points[k] = new Point(random.Next(0, 100), random.Next(0, 100));
            foreach (Point point in points)
                Console.WriteLine("{0}", point);

            //Array.Sort(points);
            //Array.Sort(points, new Point.Comparer(false));
            Array.Sort(points, new Comparer(false));
            Console.WriteLine("-- punti ordinati --");
            foreach (Point point in points)
                Console.WriteLine("{0}", point);
            Console.WriteLine("----");
        }

        private static void Step1b()
        {
            int[] array = new int[] { 23, 12, 54, 23, 65, 1 };
            foreach (int value in array)
                Console.WriteLine("{0}", value);
            Array.Sort(array, new Comparer(false));
            Console.WriteLine("-- valori ordinati --");
            foreach (int value in array)
                Console.WriteLine("{0}", value);
            Console.WriteLine("----");
        }

        private static void Step2()
        {
            Digit digit = (Digit) 5;
            char c = digit;
            Console.WriteLine("{0}", c);
            Console.WriteLine("----");
            Digits digits = new Digits();
            for (int k = 0; k <= 9; k++)
                digits.Add((Digit) k);
            Console.WriteLine("{0}", digits);
            Console.WriteLine("{0}", digits[4]);
            Console.WriteLine("----");
            digits = (Digits) "0987654321";
            Console.WriteLine("{0}", digits);
            Console.WriteLine("{0}", digits[4]);
            Console.WriteLine("----");
        }

        private static void Step3()
        {
            Color c = Color.Black;
            for (int k = 0; k < 10; k++)
            {
                Console.WriteLine(c);
                //Console.WriteLine(Enum.Format(typeof(Color), c, "F"));
                c++;
            }
            Console.WriteLine("------------");
            foreach (string s in Enum.GetNames(typeof(Color)))
                Console.WriteLine(s);
            Console.WriteLine("------------");
            foreach (int v in Enum.GetValues(typeof(Color)))
                Console.WriteLine(v);
        }

        private static void Step4()
        {
            string a = "a";
            string b = "b";
            string ab = "ab";
            string ab1 = "a" + "b";
            string ab2 = a + b;
            string ab3 = String.Intern(a + b);
            //string ab3 = String.Intern(ab2);

            Console.WriteLine("ab -> \"{0}\"", ab);
            Console.WriteLine("ab1 -> \"{0}\"", ab1);
            Console.WriteLine("ab2 -> \"{0}\"", ab2);
            Console.WriteLine("ab3 -> \"{0}\"", ab3);
            Console.WriteLine("------------");
            Console.WriteLine("ab == ab1 -> {0}", ab == ab1);
            Console.WriteLine("ab == ab2 -> {0}", ab == ab2);
            Console.WriteLine("ab == ab3 -> {0}", ab == ab3);
            Console.WriteLine("------------");
            Console.WriteLine("ab.Equals(ab1) -> {0}", ab.Equals(ab1));
            Console.WriteLine("ab.Equals(ab2) -> {0}", ab.Equals(ab2));
            Console.WriteLine("ab.Equals(ab3) -> {0}", ab.Equals(ab3));
            Console.WriteLine("------------");
            Console.WriteLine("Object.Equals(ab, ab1) -> {0}", Object.Equals(ab, ab1));
            Console.WriteLine("Object.Equals(ab, ab2) -> {0}", Object.Equals(ab, ab2));
            Console.WriteLine("Object.Equals(ab, ab3) -> {0}", Object.Equals(ab, ab3));
            Console.WriteLine("------------");
            Console.WriteLine("Object.ReferenceEquals(ab, ab1) -> {0}", Object.ReferenceEquals(ab, ab1));
            Console.WriteLine("Object.ReferenceEquals(ab, ab2) -> {0}", Object.ReferenceEquals(ab, ab2));
            Console.WriteLine("Object.ReferenceEquals(ab, ab3) -> {0}", Object.ReferenceEquals(ab, ab3));
            Console.WriteLine("------------");
            Console.WriteLine("((object) ab) == ((object) ab1) -> {0}", ((object) ab) == ((object) ab1));
            Console.WriteLine("((object) ab) == ((object) ab2) -> {0}", ((object) ab) == ((object) ab2));
            Console.WriteLine("((object) ab) == ((object) ab3) -> {0}", ((object) ab) == ((object) ab3));
            Console.WriteLine("------------");
        }

        private static void Step5()
        {
            Contenitore contenitore = new Contenitore('A', 10);
            for (int k = 0; k < contenitore.Length; k++)
                Console.Write(contenitore[k]);
            Console.WriteLine("\n----");
            foreach (char c1 in contenitore)
            {
                foreach (char c2 in contenitore)
                    Console.Write("({0},{1}) ", c1, c2);
                Console.WriteLine("");
            }
            Console.WriteLine("\n----");
        }
    }
}